<script>
	import {
		asciiToUnicode
	} from '@indicjs/ekarupa';
	import * as maps from '@indicjs/unicode-conversion-maps';

	let asciiText = '';
	let selectedMap = 'ambili';
	$: selectedMapping = maps[selectedMap];
	$: unicodeText = asciiToUnicode(asciiText, selectedMapping);

	let showAdvanced = false;

	let adding = false;
	let keytoadd = '';
	let valuetoadd = '';

	function remove(key) {
		delete selectedMapping.map[key];
		selectedMapping = selectedMapping;
	}

	function update(key, value) {
		selectedMapping.map[key] = value;
		selectedMapping = selectedMapping;
	}

	function add(key, value) {
		if (key in selectedMapping.map) {
			alert(`Key ${key} is already set. (To ${selectedMapping.map[key]})`)
			return;
		}
		selectedMapping.map[key] = value;
		adding = false;
	}
</script>
<svelte:head>
	<title>ASCII-Unicode Converter</title>
</svelte:head>

<h1>ASCII Unicode Converter</h1>

<label class="siimple-label siimple--color-white">Pick fontmap:</label>
<select bind:value={selectedMap} class="siimple-input">
	{#each maps.maps as map}
	<option value={map}>{map}</option>
	{/each}
</select>

<label class="siimple-label siimple--color-white">&nbsp;&nbsp;Show advanced settings:</label>
<input type="checkbox" bind:checked={showAdvanced} class="siimple-checkbox">
<main>
	<textarea rows=20 cols=60 placeholder="Enter ASCII Text (in {selectedMap}) here" bind:value={asciiText} class="siimple-textarea"></textarea>
	<textarea rows=20 cols=60 placeholder="Unicode Text will appear here" bind:value={unicodeText} class="siimple-textarea"></textarea>
</main>

{#if showAdvanced}
<div id="map">
	<h2>Mapping</h2>
	{#each Object.entries(selectedMapping.map) as [key, value] (key)}
	<div class="rule">
	<span class="key">{key}</span>
	<div class="value">
		<input type="text" size=3 class="siimple-input" value={value} on:input={(e) => {update(key, e.target.value)}}/>
	</div>
	<button class="delete siimple-btn siimple-btn--error" on:click="{() => remove(key)}">X</button>
	</div>
	{/each}
	{#if !adding}
		<button class="add siimple-btn" on:click={() => {adding = true}}>Add Rule</button>
	{:else}
		<div id="adding">
			<input type="text" placeholder="key" size=3 class="siimple-input" bind:value={keytoadd}>
			<input type="text" placeholder="value" size=3 class="siimple-input" bind:value={valuetoadd}>
			<button class="siimple-btn" on:click={() => add(keytoadd, valuetoadd)}>Add</button>
			<button class="siimple-btn" on:click={() => {adding = false}}>Cancel</button>
		</div>
	{/if}
</div>
{/if}
<style>
	main {
		margin-top: 1em;
		display: flex;
		justify-content: space-between;
		flex-wrap: wrap;
	}

	 textarea {
     	width: 48%;
	 }


	#map {
		margin-top: 5em;
		display: flex;
		flex-direction: column;
		gap: 1em;
		text-align: center;
	}
	.rule {
		display: flex;
		flex: 1;
		justify-content: center;
		align-items: center;
	}
	.key {
		font-size: 1.5rem;
	}
	.key, .value {
		flex: 0 0 50px;
	}
	.add {
		margin: auto;
		width: 150px;
	}

</style>